﻿function Reverse(str) {
    var rts = "";
    rts.replace(",", "");
    var i = str.length;
    i = i - 1;
    for (var x = i; x >= 0; x--) {
        rts = rts + str.charAt(x)
    }
    return rts
}

function setCookie(cname, cvalue, exdays) {
    var d = new Date;
    d.setTime(d.getTime() + exdays * 24 * 60 * 60 * 1e3);
    var expires = "expires=" + d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires
}

function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(";");
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) === " ") c = c.substring(1);
        if (c.indexOf(name) === 0) return c.substring(name.length, c.length)
    }
    return ""
}

$(window).scroll(function () {
    if ($(this).scrollTop() > 400) {
        $(".gototop-btn").fadeIn()
    } else {
        $(".gototop-btn").fadeOut()
    }
});
$(function () {
    $(document).mouseup(function (e) {
        var menu = $(".navbar-collapse");
        if (!menu.is(e.target) && menu.has(e.target).length === 0) {
            menu.collapse("hide")
        }
    })
});
var app = angular.module("majameApp", []);
app.controller("majameCTRL", function ($scope, $sce) {
    $scope.voteLanched = false;
    $scope.questionUI = 1;
    $scope.userLoggedIn = true;
    $scope.serverIPURL = "http://emajame.ir";
    $scope.serverDomainURL = "http://emajame.ir";
    $.connection.hub.qs = "ch=1";
    if (window.location.hostname.length < 3) $.connection.hub.url = $scope.serverIPURL + "/signalr";
    var connectionHub = $.connection.hub;
    connectionHub.connectionStartDone = false;
    var SRObject = $.connection.sr2;
    var token = getCookie("token");
    var storage = window.localStorage;
    if (typeof Storage !== "undefined") {
        if (!token || token.length < 5) token = storage.getItem("token")
    }
    if (token === null || token.length < 5) {
        token = "-";
        $scope.userLoggedIn = false
    }
    $scope.token = token;
    var currentPageID;
    var navigate = function (targetID) {
        if (targetID) currentPageID = targetID; else currentPageID = window.location.hash.substr(1);
        if (currentPageID === "" || $scope.userLoggedIn && currentPageID === "loginPage") {
            currentPageID = $("[data-role='page']").first().attr("ID")
        } else if ($("#" + currentPageID).length <= 0) currentPageID = window.location.hash.substr(1);
        if (currentPageID === "profilePage") {
        }
        $("#mainMenu .nav-item").removeClass("active");
        $(".nav-item > a[href$='#" + currentPageID + "']").parent().addClass("active");
        if ($("#loading").hasClass("d-none")) {
            $("#loading").removeClass("d-none");
            setTimeout(function () {
                $("#loading").addClass("d-none")
            }, 150)
        }
        $scope.currentPageID = currentPageID;
        $("[data-role='page']").addClass("d-none");
        $("#" + currentPageID).removeClass("d-none");
        switch (currentPageID) {
            case"liveAll":
            case"mainPage":
            case"conventionAll":
            case"reportAll":
                $scope.sendRequest("Default_Page", '{"":""}');
                break;
            case"preContent":
            case"contentPage":
                if (!$scope.contentPageData) {
                    if ($scope.urlParam("id") > 0) $scope.sendRequest("Content_Page", '{"ContentID":"' + $scope.urlParam("id") + '"}'); else window.location.href = "#mainPage"
                }
                break
        }
    };
    $(window).on("hashchange", function () {
        navigate()
    });
    $(function () {
        if (!$scope.userLoggedIn) window.location.href = "#loginPage"; else if (!$scope.urlParam("id")) window.location.href = "?id=13#contentPage";
        navigate();
        $scope.sendRequest("User_Load", "")
    });
    $scope.afterReload = function () {
        if (!$scope.$$phase) {
            $scope.$apply()
        }
        $('[data-toggle="tooltip"]').tooltip();
        $('[data-toggle="popover"]').popover()
    };
    $scope.kmb = function (num) {
        var temp = num;
        if (num >= 1e3 && num < 1e6) temp = (num / 1e3).toFixed(1) + "K";
        if (num >= 1e6 && num < 1e9) temp = (num / 1e6).toFixed(2) + "M";
        if (num >= 1e9) temp = (num / 1e9).toFixed(2) + "B";
        return temp
    };
    $scope.isPhoneNumber = function (inputTXT) {
        var phoneNo = /^(09)\d{9}$/;
        return inputTXT.match(phoneNo)
    };
    $scope.urlParam = function (name, url) {
        if (!url) {
            url = window.location.href
        }
        var results = new RegExp("[\\?&]" + name + "=([^&#]*)").exec(url);
        if (!results) {
            return undefined
        }
        return results[1] || undefined
    };
    $scope.sequenceNumber = 1;
    var requestQueue = [];
    $scope.sendRequest = function (functionName, arguments) {
        var item = {fn: functionName, arg: arguments, sn: 0, ts: 0};
        requestQueue.push(item);
        if (!connectionHub.connectionStartDone) $("#connectionLostModal").modal("show"); else $("#connectionLostModal").modal("hide")
    };
    $scope.getNowTS = function () {
        if (!Date.now) {
            Date.now = function () {
                return (new Date).getTime()
            }
        }
        return Math.floor(Date.now() / 1e3)
    };
    var mainInterval = setInterval(function () {
        $scope.queueIsProcessing = requestQueue.length > 0;
        if (connectionHub.connectionStartDone === true && requestQueue.length > 0) {
            var curItemIndex = -1;
            for (var i = 0; i < requestQueue.length; i++) if ($scope.getNowTS() - requestQueue[i].ts > 5 || requestQueue[i].ts === 0) curItemIndex = i;
            if (curItemIndex >= 0) {
                var item = requestQueue[curItemIndex];
                console.log(item);
                SRObject.server.fUNC(token, item.fn, item.arg, $scope.sequenceNumber);
                requestQueue[curItemIndex].sequenceNumber = $scope.sequenceNumber;
                requestQueue[curItemIndex].sentTS = $scope.getNowTS();
                $scope.sequenceNumber++
            }
        }
        $scope.afterReload()
    }, 1e3);
    SRObject.client.fUNC_Result = function (message) {
        console.log(message);
        $scope.functionData = jQuery.parseJSON(message);
        for (var i = 0; i < requestQueue.length; i++) if ($scope.functionData[0].Sequence === requestQueue[i].sequenceNumber) requestQueue.splice(i, 1);
        var jsonData = $scope.functionData[0].Info;
        switch ($scope.functionData[0].FunctionName) {
            case"Default_Page":
                $scope.loadContentList(jsonData[0]);
                break;
            case"Content_Page":
                $scope.getContent(jsonData[0]);
                break;
            case"Authentication_Code_Request":
                $scope.authenticationCodeRequestProcess(jsonData[0]);
                break;
            case"Authentication_Request":
                $scope.authenticationRequestProcess(jsonData[0]);
                break;
            case"Authentication_Token_Request":
                $scope.authenticationTokenRequestProcess(jsonData[0]);
                break;
            case"Answer_Save_Many":
                $scope.answerSaveMany(jsonData[0]);
                break;
            case"User_Load":
                $scope.userLoadProcess(jsonData[0]);
                break;
            case"User_Update":
                $scope.userUpdateProcess(jsonData[0]);
                break;
            case"Comment_Save":
                $scope.commentSaveProcess(jsonData[0]);
                break;
            case"LikeDislike_Save":
                $scope.likeDislikeResponse(jsonData[0]);
                break;
            case"Franchise_Agent_Grant_Insert":
                $scope.agentGrant(jsonData[0]);
                break;
            case"Logout_Recieved":
                $scope.logOutProcess();
                break;
            case"Franchise_Agent_Insert":
                $scope.agentInsertProcess(jsonData[0]);
                break;
            default:
                break
        }
    };
    $scope.doAfterStartDone = function () {
        connectionHub.connectionStartDone = true;
        $scope.connectionState = 2;
        $scope.afterReload()
    };
    connectionHub.start().done(function () {
        $("#connectionLostModal").modal("hide");
        $scope.doAfterStartDone()
    });
    $scope.connectionStartDoneInterval = setInterval(function () {
        if (connectionHub.connectionStartDone) {
            clearInterval($scope.connectionStartDoneInterval)
        } else {
            connectionHub.start().done(function () {
                $scope.doAfterStartDone()
            })
        }
    }, 30 * 1e3);
    connectionHub.reconnecting(function () {
        connectionHub.connectionStartDone = false;
        $scope.connectionState = 1;
        $scope.afterReload()
    });
    connectionHub.reconnected(function () {
        $("#connectionLostModal").modal("hide");
        connectionHub.connectionStartDone = true;
        $scope.connectionState = 2;
        $scope.afterReload()
    });
    connectionHub.disconnected(function () {
        $scope.connectionState = 0;
        connectionHub.connectionStartDone = false;
        $scope.afterReload();
        var connectionRefresh = setInterval(function () {
            connectionHub.start().done(function () {
                $scope.doAfterStartDone();
                clearInterval(connectionRefresh)
            })
        }, 5e3)
    });
    $scope.authenticationRequestProcess = function (jsonData) {
        $("#loading").addClass("d-none");
        if (jsonData.Result < 0) {
            $scope.token = token;
            document.cookie = "token= - ;";
            storage.setItem("token", "-");
            $scope.userLoggedIn = false
        }
    };
    $scope.mobileNumber = "";
    $scope.waitStatus = false;
    $scope.sendVerifyCode = function () {
        if ($scope.isPhoneNumber($scope.mobileNumber)) {
            $scope.waitStatus = true;
            $scope.sendVerifyWaitSecond = 60;
            $scope.refreshSendVerifyWaitSecond = 20;
            $scope.timerRefreshInterval = setInterval(function () {
                $scope.refreshSendVerifyWaitSecond--;
                console.log($scope.refreshSendVerifyWaitSecond);
                if ($scope.refreshSendVerifyWaitSecond < 0) {
                    $scope.refreshSendVerifyWaitSecond = 0;
                    clearInterval($scope.timerRefreshInterval)
                }
            }, 1e3);
            if ($scope.timerInterval) clearInterval($scope.timerInterval);
            $scope.timerInterval = setInterval(function () {
                $scope.sendVerifyWaitSecond--;
                if ($scope.sendVerifyWaitSecond < 0) {
                    $scope.sendVerifyWaitSecond = 0;
                    $scope.waitStatus = false;
                    clearInterval($scope.timerInterval)
                }
                $scope.afterReload()
            }, 1e3);
            $scope.sendRequest("Authentication_Code_Request", '{"Mobile":"' + $scope.mobileNumber.toString() + '","Method":10}');
            $scope.phoneNumberError = false
        } else {
            $scope.phoneNumberError = true;
            setTimeout(function () {
                $scope.phoneNumberError = false
            }, 5e3)
        }
        $scope.afterReload()
    };
    $scope.refreshSendVerify = function () {
        $scope.codeResultData = null;
        $scope.refreshSendVerifyWaitSecond = 1
    };
    $scope.authenticationCodeRequestProcess = function (jsonData) {
        $scope.codeNumber = "";
        $scope.waitStatus = false;
        $scope.codeResultData = jsonData;
        if ($scope.timerInterval) clearInterval($scope.timerInterval);
        if ($scope.codeResultData.Method === 10) {
            $scope.codeResultData1 = $scope.codeResultData;
            setTimeout(function () {
                $scope.showSecondMethod = true;
                $scope.afterReload()
            }, 6e4)
        } else if ($scope.codeResultData.Method === 20) {
            $scope.codeResultData2 = $scope.codeResultData
        }
        $scope.afterReload()
    };
    $scope.send4DigitVerifyCode = function () {
        $scope.waitStatus = true;
        if ($scope.timerInterval) clearInterval($scope.timerInterval);
        $scope.sendVerifyWaitSecond = 60;
        $scope.timerInterval = setInterval(function () {
            $scope.sendVerifyWaitSecond--;
            if ($scope.sendVerifyWaitSecond < 0) {
                $scope.sendVerifyWaitSecond = 0;
                $scope.waitStatus = false;
                clearInterval($scope.timerInterval)
            }
            $scope.afterReload()
        }, 1e3);
        $scope.sendRequest("Authentication_Token_Request", '{"Mobile":"' + $scope.mobileNumber.toString() + '","Code":"' + $scope.codeNumber.toString() + '"}');
        $scope.afterReload()
    };
    $scope.goToAddMobile = function () {
        $scope.codeResultData2 = $scope.showSecondMethod = $scope.codeResultData1 = null;
        $scope.afterReload()
    };
    $scope.authenticationTokenRequestProcess = function (jsonData) {
        $scope.waitStatus = false;
        if ($scope.timerInterval) clearInterval($scope.timerInterval);
        $scope.tokenRequestData = jsonData;
        if ($scope.tokenRequestData.Method === 10) $scope.tokenRequestData1 = $scope.tokenRequestData; else if ($scope.tokenRequestData.Method === 20) $scope.tokenRequestData2 = $scope.tokenRequestData;
        if ($scope.tokenRequestData.result === 0) {
            token = $scope.tokenRequestData.Token;
            $scope.token = token;
            document.cookie = "token=" + token + ";";
            storage.setItem("token", token);
            $scope.userLoggedIn = true;
            setTimeout(function () {
                window.location.href = "?id=13#contentPage"
            }, 5e10);
            $scope.sendRequest("User_Load", "")
        } else {
            setTimeout(function () {
                $scope.tokenRequestData = null
            }, 5 * 1e3);
            $scope.mobileVerifyDone = false
        }
        $scope.afterReload()
    };
    $scope.logOut = function () {
        $scope.sendRequest("Logout", "")
    };
    $scope.logOutProcess = function () {
        document.cookie = "token= '-';";
        storage.setItem("token", "-");
        $scope.userLoggedIn = false;
        $scope.showError("", "با موفقیت خارج شدید", "info", 5);
        setTimeout(function () {
            window.location.href = "#loginPage";
            location.reload()
        }, 2e3)
    };
    $scope.commentText = "";
    $scope.loadContentList = function (jsonData) {
        $scope.contentList = jsonData.Contents;
        $scope.preContentList = [];
        $scope.liveContentList = [];
        $scope.reportContentList = [];
        if ($scope.contentList) {
            $scope.contentList.forEach(function (item, key) {
                if (!item.File) {
                    $scope.contentList[key].File = {};
                    $scope.contentList[key].File.URL = $scope.serverDomainURL + "/assets/img/forumDefault.jpg"
                } else $scope.contentList[key].File.URL = $scope.serverDomainURL + "/assets/content/" + item.ID + "/" + item.File.ID + item.File.Ext + "?v=" + item.File.Update_Datetime;
                item.DateFa = new persianDate(new Date(item.Date)).format("YYYY/MM/DD HH:mm");
                switch (item.Status) {
                    case 200:
                        $scope.preContentList.push(item);
                        break;
                    case 300:
                        $scope.liveContentList.push(item);
                        break;
                    case 400:
                        $scope.reportContentList.push(item);
                        break
                }
            });
            console.log($scope.preContentList);
            console.log($scope.liveContentList);
            console.log($scope.reportContentList)
        }
    };
    $scope.getContent = function (jsonData) {
        $scope.contentPageData = jsonData;
        $scope.contentPageData.totalUserVoted = 0;
        if ($scope.contentPageData.Content) {
            $scope.contentData = $scope.contentPageData.Content[0];
            $scope.contentData.DateFa = new persianDate(new Date($scope.contentData.Date)).format("YYYY/MM/DD HH:mm");
            $scope.contentData.Link = $sce.trustAsResourceUrl($scope.contentData.Link);
            if ($scope.contentPageData.Content[0].Franchise_Agent_Grant_Enable || $scope.contentPageData.Content[0].Franchise_Agent_Insert_Enable) $scope.franchiseLaunched = true
        }
        $("#home-tab").click();
        $scope.contentPageData.Stat.countPercent = $scope.contentPageData.Stat.Total_ShareHolder_Count === 0 ? 0 : $scope.contentPageData.Stat.Online_ShareHolder_Count / $scope.contentPageData.Stat.Total_ShareHolder_Count * 100;
        $scope.contentPageData.Stat.sharePercent = $scope.contentPageData.Stat.Total_ShareHolder_Share === 0 ? 0 : $scope.contentPageData.Stat.Online_ShareHolder_Share / $scope.contentPageData.Stat.Total_ShareHolder_Share * 100;
        if (jsonData.Questions) {
            $scope.questionsData = [];
            $scope.questionsResults = [];
            jsonData.Questions.forEach(function (itemQ, keyQ) {
                jsonData.Questions[keyQ].Vote_Max = $scope.contentPageData.ShareAmount * jsonData.Questions[keyQ].Factor;
                jsonData.Questions[keyQ].totalSum = 0;
                jsonData.Questions[keyQ].totalCount = 0;
                jsonData.Questions[keyQ].totalUserVoted = 0;
                if (itemQ.Answer_Accept) $scope.questionsData.push(itemQ);
                if (itemQ.Show_Result) $scope.questionsResults.push(itemQ);
                if (jsonData.Questions[keyQ].Options) {
                    jsonData.Questions[keyQ].Options.forEach(function (itemOption) {
                        jsonData.Questions[keyQ].totalSum += itemOption.Sum;
                        jsonData.Questions[keyQ].totalCount += itemOption.Count;
                        jsonData.Questions[keyQ].totalUserVoted += itemOption.Vote
                    });
                    jsonData.Questions[keyQ].Options.forEach(function (itemOption, keyO) {
                        jsonData.Questions[keyQ].Options[keyO].percent = itemQ.totalSum === 0 ? 0 : itemOption.Sum / itemQ.totalSum * 100
                    })
                }
            });
            $scope.voteLanched = $scope.questionsData.length > 0;
            $scope.resultLanched = $scope.questionsResults.length > 0;
            if ($scope.questionsData.length === 0 && $scope.questionsResults.length === 0) $("#votingPanel").collapse("hide")
        } else {
            $scope.questionData = null
        }
        setTimeout(function () {
            $scope.resultLanched = false;
            $scope.voteLanched = false;
            $scope.franchiseLaunched = false
        }, 4e3);
        console.log($scope.contentPageData)
    };
    $scope.setVote = function (questionIndex, optionIndex) {
        if ($scope.questionsData[questionIndex].Answered) return;
        if ($scope.questionsData[questionIndex].Options[optionIndex].Vote < 0) {
            $scope.showError("errors", "رای شما نمیتواند منفی باشد", "danger", 3);
            $scope.questionsData[questionIndex].Options[optionIndex].Vote = 0
        } else if (!isNaN($scope.questionsData[questionIndex].Options[optionIndex].Vote)) {
            $scope.questionsData[questionIndex].totalUserVoted = 0;
            $scope.questionsData[questionIndex].Options.forEach(function (item) {
                $scope.questionsData[questionIndex].totalUserVoted += item.Vote
            });
            $scope.questionsData[questionIndex].totalUserVoted2 = $scope.questionsData[questionIndex].totalUserVoted - $scope.questionsData[questionIndex].Options[optionIndex].Vote;
            if ($scope.questionsData[questionIndex].totalUserVoted > $scope.questionsData[questionIndex].Vote_Max) {
                $scope.questionsData[questionIndex].totalUserVoted = $scope.questionsData[questionIndex].Vote_Max;
                $scope.questionsData[questionIndex].Options[optionIndex].Vote = $scope.questionsData[questionIndex].totalUserVoted - $scope.questionsData[questionIndex].totalUserVoted2;
                $scope.showError("errors", "به حداکثر رای مجاز رسیدید.", "info", 3)
            }
        }
    };
    $scope.selectOption = function (questionIndex, optionIndex) {
        if ($scope.questionsData[questionIndex].Answered) return;
        $scope.questionsData[questionIndex].Options.forEach(function (item, K) {
            $scope.questionsData[questionIndex].Options[K].Vote = 0
        });
        $scope.questionsData[questionIndex].totalUserVoted = $scope.questionsData[questionIndex].Options[optionIndex].Vote = $scope.questionsData[questionIndex].Vote_Max
    };
    $scope.submitVote = function (questionIndex) {
        if ($scope.questionsData[questionIndex].Answered) return;
        var argument = '{"QuestionID":' + $scope.questionsData[questionIndex].ID + ', "Answers" : [ ';
        if ($scope.questionsData[questionIndex].TypeID === 400) {
            $scope.questionsData[questionIndex].Options.forEach(function (item) {
                if (isNaN(item.Vote)) item.Vote = 0;
                argument += ' { "OptionID":' + item.ID + ',"Vote":' + item.Vote + " },"
            });
            argument = argument.substr(0, argument.length - 1)
        } else if ($scope.questionsData[questionIndex].TypeID === 100) {
            $scope.questionsData[questionIndex].Options.forEach(function (item) {
                if (isNaN(item.Vote)) item.Vote = 0;
                if (item.Vote > 0) argument += ' { "OptionID":' + item.ID + ',"Vote":' + item.Vote + " }"
            })
        }
        argument += "]}";
        $scope.sendRequest("Answer_Save_Many", argument)
    };
    $scope.answerSaveMany = function (jsonData) {
        $scope.answerSaveManyData = jsonData.result[0];
        $scope.questionsData.forEach(function (item, key) {
            if (item.ID === $scope.answerSaveManyData.QuestionID) {
                $scope.questionsData[key].Answered = true;
                $scope.showError("questionError" + item.ID, $scope.answerSaveManyData.Message, $scope.answerSaveManyData.Result == 0 ? "success" : "danger", 5)
            }
        });
        setTimeout(function () {
            $scope.answerSaveManyData = null
        }, 5e3)
    };
    $scope.userLoadProcess = function (jsonData) {
        $("#loading").addClass("d-none");
        $scope.userData = jsonData.User[0];
        $scope.userFranchiseData = jsonData.Franchise;
        console.log("userData");
        console.log(jsonData)
    };
    $(".changeable").change(function () {
        if ($(this).data("needreload")) $scope.needReload = true;
        $(this).addClass("changing");
        if ($(this).attr("id") !== null) {
            $scope.changeRequestSent = 1;
            var val = $(this).val();
            if (val.substring(0, 7) === "number:" || val.substring(0, 7) === "string:") val = val.substring(7)
        }
        if (currentPageID === "profilePage") $scope.sendRequest("User_Update", '{"Field":"' + $(this).attr("id") + '","Value":"' + val + '"}'); else if (currentPageID === "profilePage") $scope.sendRequest("Company_Update", '{"Field":"' + $(this).attr("id") + '","Value":"' + val + '"}')
    });
    $scope.userUpdateProcess = function (jsonData) {
        if (jsonData.result[0].Result !== 0) $scope.sendRequest("User_Load", "");
        $(".changing").removeClass("changing");
        $scope.userData.DisplayName = $scope.userData.Name + "  " + $scope.userData.Family;
        $scope.showError("", jsonData.result[0].Message, jsonData.result[0].Result === 0 ? "success" : "danger", 5)
    };
    $scope.commentIsSent = false;
    $scope.sendComment = function () {
        if ($scope.commentIsSent === false && $scope.userData) {
            $scope.sendRequest("Comment_Save", '{"Text":"' + $scope.commentText + '","ParentType":10,"ParentID":' + $scope.contentData.ID + "}");
            $scope.commentIsSent = true
        } else if (!$scope.userData) $scope.showError("", "لطفا برای ثبت نظر، وارد سایت شوید", "danger", 5)
    };
    $scope.commentSaveProcess = function (jsonData) {
        $scope.commentIsSent = false;
        $scope.commentSentData = jsonData;
        console.log(jsonData);
        $scope.showError("", jsonData.result[0].Message, jsonData.result[0].Result === 0 ? "success" : "danger", 5);
        if (!$scope.contentPageData.Comments) $scope.contentPageData.Comments = [];
        $scope.contentPageData.Comments.unshift({
            Text: $scope.commentText,
            TimePassed: "لحظاتی پیش",
            ID: jsonData.result[0].ID,
            ParentType: jsonData.result[0].ParentType,
            ParentID: jsonData.result[0].ParentID,
            Like: 0,
            Dislike: 0,
            User: {DisplayName: $scope.userData.DisplayName, ID: $scope.userData.ID}
        });
        $scope.commentText = ""
    };
    $scope.likeDislike = function (parentType, parentID, score) {
        if ($scope.contentPageData.Comments[parentID].Score) {
            if ($scope.contentPageData.Comments[parentID].Score > 0) $scope.contentPageData.Comments[parentID].Like--; else $scope.contentPageData.Comments[parentID].Dislike--
        }
        $scope.contentPageData.Comments[parentID].Score = score;
        console.log('LikeDislike_Save {"ParentType":' + parentType + ',"ParentID":' + $scope.contentPageData.Comments[parentID].ID + ',"Score":' + score + "}");
        $scope.sendRequest("LikeDislike_Save", '{"ParentType":' + parentType + ',"ParentID":' + $scope.contentPageData.Comments[parentID].ID + ',"Score":' + score + "}");
        if (score > 0) $scope.contentPageData.Comments[parentID].Like++; else $scope.contentPageData.Comments[parentID].Dislike++
    };
    $scope.likeDislikeResponse = function (jsonData) {
        console.log(jsonData)
    };
    $scope.selectAgent = function (agentID) {
        $scope.selectedAgentID = agentID;
        $scope.contentPageData.Franchise_Agents.forEach(function (agent, key) {
            $scope.contentPageData.Franchise_Agents[key].Selected = agent.ID === agentID;
            if (agent.ID === agentID) $scope.selectedAgent = agent
        })
    };
    $scope.submitAgent = function () {
        if ($scope.selectedAgent) {
            $scope.sendRequest("Franchise_Agent_Grant_Insert", '{"ContentID":"1","ShareHolderType":"100","ShareHolderID":"' + $scope.selectedAgent.ID + '"}')
        }
    };
    $scope.agentGrant = function (jsonData) {
        $scope.showError("", jsonData.result[0].Message, jsonData.result[0].Result === 0 ? "success" : "danger", 5)
    };
    $scope.agentInsert = function () {
        $scope.sendRequest("Franchise_Agent_Insert", '{"ContentID":"1"}')
    };
    $scope.agentInsertProcess = function (jsonData) {
        $scope.showError("", jsonData.result[0].Message, jsonData.result[0].Result === 0 ? "success" : "danger", 5)
    };
    $scope.imageChanged = false;
    var crop_max_width;
    var crop_max_height = crop_max_width = $("#uploadImg").width();
    var jcrop_api;
    var canvas;
    var context;
    var prefsize;
    $("input[type=file]").change(function () {
        var fileType = this.files[0].type;
        var ValidImageTypes = ["image/gif", "image/jpeg", "image/png"];
        if ($.inArray(fileType, ValidImageTypes) >= 0) loadImage(this); else $scope.imageSave = {
            Result: -50,
            Message: "لطفا عکس آپلود نمایید."
        };
        $scope.afterReload()
    });
    $("#editPicModal").on("shown.bs.modal", function (e) {
        loadImage("/assets/user/" + $scope.userData.ID + ".jpg?v=" + Math.random());
        crop_max_height = crop_max_width = $("#uploadImg").width();
        validateImage()
    });

    function showImgState() {
        var blob = dataURLtoBlob(canvas.toDataURL("image/jpeg"));
        $scope.userIMG = {
            size: blob.size,
            width: canvas.width,
            height: canvas.height,
            sizeTXT: "",
            ratioIsValid: false
        };
        if ($scope.userIMG.size < 1e3) $scope.userIMG.sizeTXT = $scope.userIMG.size + "B"; else if ($scope.userIMG.size < 1e6) $scope.userIMG.sizeTXT = Math.round($scope.userIMG.size / 1e3) + "KB"; else $scope.userIMG.sizeTXT = Math.round($scope.userIMG.size / 1e5) / 10 + "MB";
        if (Math.abs(1 * canvas.width / canvas.height - 1 * crop_max_width / crop_max_height) < .05) $scope.userIMG.ratioIsValid = true;
        $scope.afterReload()
    }

    function loadImage(input) {
        $scope.imageisLoading = true;
        if (input && input.files && input.files[0]) {
            $scope.imageChanged = true;
            $scope.afterReload();
            var reader = new FileReader;
            canvas = null;
            reader.onload = function (e) {
                $scope.image = new Image;
                $scope.image.onload = validateImage;
                $scope.image.src = e.target.result
            };
            reader.readAsDataURL(input.files[0])
        } else {
            $scope.image = new Image;
            $scope.image.onload = restartJcrop;
            $scope.image.src = input
        }
    }

    function validateImage() {
        if (canvas != null) {
            $scope.image = new Image;
            $scope.image.onload = restartJcrop;
            $scope.image.src = canvas.toDataURL("image/jpeg")
        } else restartJcrop();
        showImgState()
    }

    function dataURLtoBlob(dataURL) {
        var BASE64_MARKER = ";base64,";
        if (dataURL.indexOf(BASE64_MARKER) === -1) {
            var parts = dataURL.split(",");
            var contentType = parts[0].split(":")[1];
            var raw = decodeURIComponent(parts[1]);
            return new Blob([raw], {type: contentType})
        }
        var parts = dataURL.split(BASE64_MARKER);
        var contentType = parts[0].split(":")[1];
        var raw = window.atob(parts[1]);
        var rawLength = raw.length;
        var uInt8Array = new Uint8Array(rawLength);
        for (var i = 0; i < rawLength; ++i) {
            uInt8Array[i] = raw.charCodeAt(i)
        }
        return new Blob([uInt8Array], {type: contentType})
    }

    function clearBG4PNG() {
        context.fillStyle = "#fff";
        context.fillRect(0, 0, canvas.width, canvas.height)
    }

    function restartJcrop() {
        if ($("input[type=file]")) $("input[type=file]").val("");
        $scope.imageisLoading = false;
        if (jcrop_api != null) {
            jcrop_api.destroy()
        }
        $("#uploadImg").empty().append('<canvas id="canvas">');
        canvas = $("#canvas")[0];
        context = canvas.getContext("2d");
        canvas.width = $scope.image.width;
        canvas.height = $scope.image.height;
        clearBG4PNG();
        context.drawImage($scope.image, 0, 0);
        $("#canvas").Jcrop({
            onSelect: selectcanvas,
            onRelease: clearcanvas,
            boxWidth: crop_max_width,
            boxHeight: crop_max_height,
            aspectRatio: crop_max_width / crop_max_height
        }, function () {
            jcrop_api = this
        });
        clearcanvas();
        showImgState()
    }

    function clearcanvas() {
        prefsize = {x: 0, y: 0, w: canvas.width, h: canvas.height};
        $scope.cropSelected = false;
        $scope.afterReload()
    }

    function selectcanvas(coords) {
        prefsize = {x: Math.round(coords.x), y: Math.round(coords.y), w: Math.round(coords.w), h: Math.round(coords.h)};
        $scope.cropSelected = true;
        $scope.afterReload()
    }

    function applyCrop() {
        $scope.imageChanged = true;
        $scope.afterReload();
        canvas.width = prefsize.w;
        canvas.height = prefsize.h;
        clearBG4PNG();
        context.drawImage($scope.image, prefsize.x, prefsize.y, prefsize.w, prefsize.h, 0, 0, canvas.width, canvas.height);
        validateImage()
    }

    function applyRotate() {
        $scope.imageChanged = true;
        $scope.afterReload();
        canvas.width = $scope.image.height;
        canvas.height = $scope.image.width;
        context.clearRect(0, 0, canvas.width, canvas.height);
        context.translate($scope.image.height / 2, $scope.image.width / 2);
        context.rotate(Math.PI / 2);
        clearBG4PNG();
        context.drawImage($scope.image, -$scope.image.width / 2, -$scope.image.height / 2);
        validateImage()
    }

    function applyHflip() {
        $scope.imageChanged = true;
        $scope.afterReload();
        context.clearRect(0, 0, canvas.width, canvas.height);
        context.translate($scope.image.width, 0);
        context.scale(-1, 1);
        clearBG4PNG();
        context.drawImage($scope.image, 0, 0);
        validateImage()
    }

    function applyVflip() {
        $scope.imageChanged = true;
        $scope.afterReload();
        context.clearRect(0, 0, canvas.width, canvas.height);
        context.translate(0, $scope.image.height);
        context.scale(1, -1);
        clearBG4PNG();
        context.drawImage($scope.image, 0, 0);
        validateImage()
    }

    $scope.applyScale = function (scale) {
        if (scale === 1) return;
        canvas.width = canvas.width * scale;
        canvas.height = canvas.height * scale;
        clearBG4PNG();
        context.drawImage($scope.image, 0, 0, canvas.width, canvas.height);
        validateImage()
    };
    $("#cropbutton").click(function (e) {
        applyCrop()
    });
    $("#rotatebutton").click(function (e) {
        applyRotate()
    });
    $("#hflipbutton").click(function (e) {
        applyHflip()
    });
    $("#vflipbutton").click(function (e) {
        applyVflip()
    });
    $(".saveCroppedBtn").click(function () {
        if (canvas.width > 200) {
            if (Math.abs(1 * canvas.width / canvas.height - 1 * crop_max_width / crop_max_height) < .05) {
                if ($scope.userIMG.size > 2e5) $scope.applyScale(2e5 / $scope.userIMG.size);
                var blob = canvas.toDataURL("image/jpeg");
                var formData = new FormData;
                formData.append("EntityType", "Question");
                formData.append("EntityID", $scope.questionID);
                formData.append("img", blob);
                $scope.changeRequestSent = 1;
                $scope.sendRequest("User_Update", '{"Field":"Image","Value":"' + blob + '"')
            } else $scope.imageSave = {
                Result: -50,
                Message: "برای ذخیره سازی عکس شما، لطفا عکس را در ابعاد مناسب برش بزنید."
            }
        } else $scope.imageSave = {
            Result: -50,
            Message: "سایز عکس آپلود شده بسیار کوچک است، لطفا سایز بزرگتر آپلود فرمایید."
        };
        $scope.afterReload();
        setTimeout(function () {
            $scope.currentFieldInfo = null;
            $scope.afterReload()
        }, 5e3)
    });
    $("#cancelEditIMG").click(function () {
        loadImage("/assets/user/" + $scope.userData.ID + ".jpg?v=" + Math.random());
        $("#editPicModal").modal("hide")
    });
    $scope.showError = function (parentDivId, text, type, second) {
        if (parentDivId === "") parentDivId = "errors";
        var icon = "";
        switch (type) {
            case"success":
                icon = '<b><i class="material-icons float-right pl-2">done</i></b>';
                break;
            case"warning":
                icon = '<b><i class="material-icons float-right pl-2">warning</i></b>';
                break;
            case"info":
                icon = '<b><i class="material-icons float-right pl-2">info</i></b>';
                break;
            case"danger":
            default:
                icon = '<b><i class="material-icons float-right pl-2">error</i></b>';
                break
        }
        var newDivId = parentDivId + Math.random();
        $("#" + parentDivId).append("<div class='alert alert-" + type + "' id='" + newDivId + "'>" + icon + text + "</div>");
        if (!second || second === 0) second = 3;
        setTimeout(function () {
            document.getElementById(parentDivId).removeChild(document.getElementById(newDivId))
        }, second * 1e3)
    };
    $scope.toggleLike = function () {
        $scope.contentPageData.like = !$scope.contentPageData.like;
        if ($scope.contentPageData.like) $scope.contentPageData.likeNumber++; else $scope.contentPageData.likeNumber--
    };
    $scope.toggleCollapse = function (id) {
        $("#" + id).toggleClass("show")
    }
});